package com.jdbernard.teammaker

import org.apache.log4j.Logger

public abstract class PlayerChooser {

    // ======== CLASS DATA ======== //
    protected static final Random rand = new Random(System.currentTimeMillis())

    // ======== PUBLIC METHODS ======== //
    public abstract Player choose (def players)
    public abstract float getOdds(def players, Player player)

    // ======== INSTANCE DATA ======== //
    protected Logger log = Logger.getLogger(getClass())

    // ======== NON-PUBLIC METHODS ======== //
    protected Player chooseRandomly(List choices) {

        if (log.isTraceEnabled())
            log.trace("Choosing randomly from: ${choices})")

        choices.sort { rand.nextInt() }

        if (log.isTraceEnabled()) log.trace("Chose: ${choices[0]}")

        return choices[0]
    }
}
